Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 512)
@@ -2499,121 +3036,273 @@
    *
    */
-  maps *_tmpMaps=(maps*)malloc(MAPS_SIZE);
-  _tmpMaps->name=zStrdup("lenv");
-  char tmpBuff[100];
-  sprintf(tmpBuff,"%i",(cpid+(int)time(NULL)));
-  _tmpMaps->content=createMap("usid",tmpBuff);
-  _tmpMaps->next=NULL;
-  sprintf(tmpBuff,"%i",cpid);
-  addToMap(_tmpMaps->content,"sid",tmpBuff);
-  addToMap(_tmpMaps->content,"status","0");
-  addToMap(_tmpMaps->content,"cwd",ntmp);
-  addToMap(_tmpMaps->content,"message",_("No message provided"));
-  map* ltmp=getMap(request_inputs,"soap");
-  if(ltmp!=NULL)
-    addToMap(_tmpMaps->content,"soap",ltmp->value);
-  else
-    addToMap(_tmpMaps->content,"soap","false");
-  if(cgiCookie!=NULL && strlen(cgiCookie)>0){
-    int hasValidCookie=-1;
-    char *tcook=zStrdup(cgiCookie);
-    char *tmp=NULL;
-    map* testing=getMapFromMaps(m,"main","cookiePrefix");
-    if(testing==NULL){
-      tmp=zStrdup("ID=");
-    }else{
-      tmp=(char*)malloc((strlen(testing->value)+2)*sizeof(char));
-      sprintf(tmp,"%s=",testing->value);
-    }
-    if(strstr(cgiCookie,";")!=NULL){
-      char *token,*saveptr;
-      token=strtok_r(cgiCookie,";",&saveptr);
-      while(token!=NULL){
-	if(strcasestr(token,tmp)!=NULL){
-	  if(tcook!=NULL)
-	    free(tcook);
-	  tcook=zStrdup(token);
-	  hasValidCookie=1;
-	}
-	token=strtok_r(NULL,";",&saveptr);
-      }
-    }else{
-      if(strstr(cgiCookie,"=")!=NULL && strcasestr(cgiCookie,tmp)!=NULL){
-	tcook=zStrdup(cgiCookie);
-	hasValidCookie=1;
-      }
-      if(tmp!=NULL){
-	free(tmp);
-      }
-    }
-    if(hasValidCookie>0){
-      addToMap(_tmpMaps->content,"sessid",strstr(tcook,"=")+1);
-      char session_file_path[1024];
-      map *tmpPath=getMapFromMaps(m,"main","sessPath");
-      if(tmpPath==NULL)
-	tmpPath=getMapFromMaps(m,"main","tmpPath");
-      char *tmp1=strtok(tcook,";");
-      if(tmp1!=NULL)
-	sprintf(session_file_path,"%s/sess_%s.cfg",tmpPath->value,strstr(tmp1,"=")+1);
-      else
-	sprintf(session_file_path,"%s/sess_%s.cfg",tmpPath->value,strstr(cgiCookie,"=")+1);
-      free(tcook);
-      maps *tmpSess=(maps*)malloc(MAPS_SIZE);
-      struct stat file_status;
-      int istat = stat(session_file_path, &file_status);
-      if(istat==0 && file_status.st_size>0){
-	conf_read(session_file_path,tmpSess);
-	addMapsToMaps(&m,tmpSess);
-	freeMaps(&tmpSess);
-	free(tmpSess);
-      }
-    }
-  }
-  addMapsToMaps(&m,_tmpMaps);
-  freeMaps(&_tmpMaps);
-  free(_tmpMaps);
-  
-#ifdef DEBUG
-  dumpMap(request_inputs);
+                                                         maps * _tmpMaps =
+                                                         (maps *)
+                                                         malloc (MAPS_SIZE);
+                                                         _tmpMaps->name =
+                                                         zStrdup ("lenv");
+                                                         char tmpBuff[100];
+                                                         sprintf (tmpBuff,
+                                                                  "%i",
+                                                                  (cpid +
+                                                                   (int)
+                                                                   time
+                                                                   (NULL)));
+                                                         _tmpMaps->content =
+                                                         createMap ("usid",
+                                                                    tmpBuff);
+                                                         _tmpMaps->next =
+                                                         NULL;
+                                                         sprintf (tmpBuff,
+                                                                  "%i", cpid);
+                                                         addToMap
+                                                         (_tmpMaps->content,
+                                                          "sid", tmpBuff);
+                                                         addToMap
+                                                         (_tmpMaps->content,
+                                                          "status", "0");
+                                                         addToMap
+                                                         (_tmpMaps->content,
+                                                          "cwd", ntmp);
+                                                         addToMap
+                                                         (_tmpMaps->content,
+                                                          "message",
+                                                          _
+                                                          ("No message provided"));
+                                                         map * ltmp =
+                                                         getMap
+                                                         (request_inputs,
+                                                          "soap");
+                                                         if (ltmp !=
+                                                             NULL)
+                                                         addToMap
+                                                         (_tmpMaps->content,
+                                                          "soap",
+                                                          ltmp->value);
+                                                         else
+                                                         addToMap
+                                                         (_tmpMaps->content,
+                                                          "soap", "false");
+                                                         if (cgiCookie != NULL
+                                                             &&
+                                                             strlen
+                                                             (cgiCookie) > 0)
+                                                         {
+                                                         int hasValidCookie =
+                                                         -1;
+                                                         char *tcook =
+                                                         zStrdup (cgiCookie);
+                                                         char *tmp = NULL;
+                                                         map * testing =
+                                                         getMapFromMaps (m,
+                                                                         "main",
+                                                                         "cookiePrefix");
+                                                         if (testing == NULL)
+                                                         {
+                                                         tmp =
+                                                         zStrdup ("ID=");}
+                                                         else
+                                                         {
+                                                         tmp =
+                                                         (char *)
+                                                         malloc ((strlen
+                                                                  (testing->
+                                                                   value) +
+                                                                  2) *
+                                                                 sizeof
+                                                                 (char));
+                                                         sprintf (tmp, "%s=",
+                                                                  testing->
+                                                                  value);}
+                                                         if (strstr
+                                                             (cgiCookie,
+                                                              ";") != NULL)
+                                                         {
+                                                         char *token,
+                                                         *saveptr;
+                                                         token =
+                                                         strtok_r (cgiCookie,
+                                                                   ";",
+                                                                   &saveptr);
+                                                         while (token != NULL)
+                                                         {
+                                                         if (strcasestr
+                                                             (token,
+                                                              tmp) != NULL)
+                                                         {
+                                                         if (tcook != NULL)
+                                                         free (tcook);
+                                                         tcook =
+                                                         zStrdup (token);
+                                                         hasValidCookie = 1;}
+                                                         token =
+                                                         strtok_r (NULL, ";",
+                                                                   &saveptr);}
+                                                         }
+                                                         else
+                                                         {
+                                                         if (strstr
+                                                             (cgiCookie,
+                                                              "=") != NULL
+                                                             &&
+                                                             strcasestr
+                                                             (cgiCookie,
+                                                              tmp) != NULL)
+                                                         {
+                                                         tcook =
+                                                         zStrdup (cgiCookie);
+                                                         hasValidCookie = 1;}
+                                                         if (tmp != NULL)
+                                                         {
+                                                         free (tmp);}
+                                                         }
+                                                         if (hasValidCookie >
+                                                             0)
+                                                         {
+                                                         addToMap
+                                                         (_tmpMaps->content,
+                                                          "sessid",
+                                                          strstr (tcook,
+                                                                  "=") + 1);
+                                                         char
+                                                         session_file_path
+                                                         [1024];
+                                                         map * tmpPath =
+                                                         getMapFromMaps (m,
+                                                                         "main",
+                                                                         "sessPath");
+                                                         if (tmpPath ==
+                                                             NULL) tmpPath =
+                                                         getMapFromMaps (m,
+                                                                         "main",
+                                                                         "tmpPath");
+                                                         char *tmp1 =
+                                                         strtok (tcook, ";");
+                                                         if (tmp1 !=
+                                                             NULL)
+                                                         sprintf
+                                                         (session_file_path,
+                                                          "%s/sess_%s.cfg",
+                                                          tmpPath->value,
+                                                          strstr (tmp1,
+                                                                  "=") + 1);
+                                                         else
+                                                         sprintf
+                                                         (session_file_path,
+                                                          "%s/sess_%s.cfg",
+                                                          tmpPath->value,
+                                                          strstr (cgiCookie,
+                                                                  "=") + 1);
+                                                         free (tcook);
+                                                         maps * tmpSess =
+                                                         (maps *)
+                                                         malloc (MAPS_SIZE);
+                                                         struct stat
+                                                         file_status;
+                                                         int istat =
+                                                         stat
+                                                         (session_file_path,
+                                                          &file_status);
+                                                         if (istat == 0
+                                                             &&
+                                                             file_status.
+                                                             st_size > 0)
+                                                         {
+                                                         conf_read
+                                                         (session_file_path,
+                                                          tmpSess);
+                                                         addMapsToMaps (&m,
+                                                                        tmpSess);
+                                                         freeMaps (&tmpSess);
+                                                         free (tmpSess);}
+                                                         }
+                                                         }
+                                                         addMapsToMaps (&m,
+                                                                        _tmpMaps);
+                                                         freeMaps (&_tmpMaps);
+                                                         free (_tmpMaps);
+#ifdef DEBUG
+                                                         dumpMap
+                                                         (request_inputs);
 #endif
 #ifdef WIN32
-  char *cgiSidL=NULL;
-  if(getenv("CGISID")!=NULL)
-    addToMap(request_inputs,"cgiSid",getenv("CGISID"));
-  map* test1=getMap(request_inputs,"cgiSid");
-  if(test1!=NULL){
-    cgiSid=test1->value;
-    addToMap(request_inputs,"storeExecuteResponse","true");
-    addToMap(request_inputs,"status","true");
-    setMapInMaps(m,"lenv","sid",test1->value);
-    status=getMap(request_inputs,"status");
-  }
-#endif
-  char *fbkp,*fbkp1;
-  FILE *f0,*f1;
-  if(status!=NULL)
-    if(strcasecmp(status->value,"false")==0)
-      status=NULLMAP;
-  if(status==NULLMAP){
-    loadServiceAndRun(&m,s1,request_inputs,&request_input_real_format,&request_output_real_format,&eres);
-  }
-  else{
-    int   pid;
-#ifdef DEBUG
-    fprintf(stderr,"\nPID : %d\n",cpid);
-#endif
-
+                                                         char *cgiSidL = NULL;
+                                                         if (getenv ("CGISID")
+                                                             !=
+                                                             NULL)
+                                                         addToMap
+                                                         (request_inputs,
+                                                          "cgiSid",
+                                                          getenv ("CGISID"));
+                                                         map * test1 =
+                                                         getMap
+                                                         (request_inputs,
+                                                          "cgiSid");
+                                                         if (test1 != NULL)
+                                                         {
+                                                         cgiSid =
+                                                         test1->value;
+                                                         addToMap
+                                                         (request_inputs,
+                                                          "storeExecuteResponse",
+                                                          "true");
+                                                         addToMap
+                                                         (request_inputs,
+                                                          "status", "true");
+                                                         setMapInMaps (m,
+                                                                       "lenv",
+                                                                       "sid",
+                                                                       test1->
+                                                                       value);
+                                                         status =
+                                                         getMap
+                                                         (request_inputs,
+                                                          "status");}
+#endif
+                                                         char *fbkp, *fbkp1;
+                                                         FILE * f0, *f1;
+                                                         if (status != NULL)
+                                                         if (strcasecmp
+                                                             (status->value,
+                                                              "false") ==
+                                                             0) status =
+                                                         NULLMAP;
+                                                         if (status ==
+                                                             NULLMAP)
+                                                         {
+                                                         loadServiceAndRun
+                                                         (&m, s1,
+                                                          request_inputs,
+                                                          &request_input_real_format,
+                                                          &request_output_real_format,
+                                                          &eres);}
+                                                         else
+                                                         {
+                                                         int pid;
+#ifdef DEBUG
+                                                         fprintf (stderr,
+                                                                  "\nPID : %d\n",
+                                                                  cpid);
+#endif
 #ifndef WIN32
-    pid = fork ();
+                                                         pid = fork ();
 #else
-    if(cgiSid==NULL){
-      createProcess(m,request_inputs,s1,NULL,cpid,request_input_real_format,request_output_real_format);
-      pid = cpid;
-    }else{
-      pid=0;
-      cpid=atoi(cgiSid);
-    }
-#endif
-    if (pid > 0) {
+                                                         if (cgiSid == NULL)
+                                                         {
+                                                         createProcess (m,
+                                                                        request_inputs,
+                                                                        s1,
+                                                                        NULL,
+                                                                        cpid,
+                                                                        request_input_real_format,
+                                                                        request_output_real_format);
+                                                         pid = cpid;}
+                                                         else
+                                                         {
+                                                         pid = 0;
+                                                         cpid =
+                                                         atoi (cgiSid);}
+#endif
+                                                         if (pid > 0)
+                                                         {
       /**
        * dady :
@@ -2621,29 +3310,82 @@
        */
 #ifdef DEBUG
-      fprintf(stderr,"father pid continue (origin %d) %d ...\n",cpid,getpid());
-#endif
-      eres=SERVICE_ACCEPTED;
-    }else if (pid == 0) {
+                                                         fprintf (stderr,
+                                                                  "father pid continue (origin %d) %d ...\n",
+                                                                  cpid,
+                                                                  getpid ());
+#endif
+                                                         eres =
+                                                         SERVICE_ACCEPTED;}
+                                                         else
+                                                         if (pid == 0)
+                                                         {
       /**
        * son : have to close the stdout, stdin and stderr to let the parent
        * process answer to http client.
        */
-      r_inputs=getMapFromMaps(m,"main","tmpPath");
-      map* r_inputs1=getMap(s1->content,"ServiceProvider");
-      fbkp=(char*)malloc((strlen(r_inputs->value)+strlen(r_inputs1->value)+1024)*sizeof(char));
-      sprintf(fbkp,"%s/%s_%d.xml",r_inputs->value,r_inputs1->value,cpid);
-      char* flog=(char*)malloc((strlen(r_inputs->value)+strlen(r_inputs1->value)+1024)*sizeof(char));
-      sprintf(flog,"%s/%s_%d_error.log",r_inputs->value,r_inputs1->value,cpid);
-#ifdef DEBUG
-      fprintf(stderr,"RUN IN BACKGROUND MODE \n");
-      fprintf(stderr,"son pid continue (origin %d) %d ...\n",cpid,getpid());
-      fprintf(stderr,"\nFILE TO STORE DATA %s\n",r_inputs->value);
-#endif
-      freopen(flog, "w+", stderr);
-      f0=freopen(fbkp , "w+", stdout);
+                                                         r_inputs =
+                                                         getMapFromMaps (m,
+                                                                         "main",
+                                                                         "tmpPath");
+                                                         map * r_inputs1 =
+                                                         getMap (s1->content,
+                                                                 "ServiceProvider");
+                                                         fbkp =
+                                                         (char *)
+                                                         malloc ((strlen
+                                                                  (r_inputs->
+                                                                   value) +
+                                                                  strlen
+                                                                  (r_inputs1->
+                                                                   value) +
+                                                                  1024) *
+                                                                 sizeof
+                                                                 (char));
+                                                         sprintf (fbkp,
+                                                                  "%s/%s_%d.xml",
+                                                                  r_inputs->
+                                                                  value,
+                                                                  r_inputs1->
+                                                                  value,
+                                                                  cpid);
+                                                         char *flog =
+                                                         (char *)
+                                                         malloc ((strlen
+                                                                  (r_inputs->
+                                                                   value) +
+                                                                  strlen
+                                                                  (r_inputs1->
+                                                                   value) +
+                                                                  1024) *
+                                                                 sizeof
+                                                                 (char));
+                                                         sprintf (flog,
+                                                                  "%s/%s_%d_error.log",
+                                                                  r_inputs->
+                                                                  value,
+                                                                  r_inputs1->
+                                                                  value,
+                                                                  cpid);
+#ifdef DEBUG
+                                                         fprintf (stderr,
+                                                                  "RUN IN BACKGROUND MODE \n");
+                                                         fprintf (stderr,
+                                                                  "son pid continue (origin %d) %d ...\n",
+                                                                  cpid,
+                                                                  getpid ());
+                                                         fprintf (stderr,
+                                                                  "\nFILE TO STORE DATA %s\n",
+                                                                  r_inputs->
+                                                                  value);
+#endif
+                                                         freopen (flog, "w+",
+                                                                  stderr);
+                                                         f0 =
+                                                         freopen (fbkp, "w+",
+                                                                  stdout);
 #ifndef WIN32
-      fclose(stdin);
-#endif
-      free(flog);
+                                                         fclose (stdin);
+#endif
+                                                         free (flog);
       /**
        * set status to SERVICE_STARTED and flush stdout to ensure full 
